package com.xmomen.module.base.entity;

import com.xmomen.framework.mybatis.model.BaseMybatisExample;
import java.util.ArrayList;
import java.util.List;

// 定义一个CdCouponRefExample类，继承自BaseMybatisExample类
public class CdCouponRefExample extends BaseMybatisExample {
    // 定义一个orderByClause变量，用于存储排序字段
    protected String orderByClause;

    // 定义一个distinct变量，用于存储是否去重
    protected boolean distinct;

    // 定义一个oredCriteria变量，用于存储查询条件
    protected List<Criteria> oredCriteria;

    // 构造函数，初始化oredCriteria变量
    public CdCouponRefExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    // 设置orderByClause变量的值
    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    // 获取orderByClause变量的值
    public String getOrderByClause() {
        return orderByClause;
    }

    // 设置distinct变量的值
    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    // 获取distinct变量的值
    public boolean isDistinct() {
        return distinct;
    }

    // 获取oredCriteria变量的值
    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    // 添加一个查询条件
    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    // 创建一个新的查询条件
    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    // 创建一个新的查询条件
    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    // 创建一个新的查询条件
    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    // 清空oredCriteria变量和orderByClause变量和distinct变量的值
    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    // 定义一个GeneratedCriteria类，用于存储查询条件
    protected abstract static class GeneratedCriteria {
        // 定义一个criteria变量，用于存储查询条件
        protected List<Criterion> criteria;

        // 构造函数，初始化criteria变量
        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        // 判断是否有查询条件
        public boolean isValid() {
            return criteria.size() > 0;
        }

        // 获取所有的查询条件
        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        // 获取查询条件
        public List<Criterion> getCriteria() {
            return criteria;
        }

        // 添加一个查询条件
        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        // 添加一个查询条件
        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        // 添加一个查询条件
        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        // 判断ID是否为空
        public Criteria andIdIsNull() {
            addCriterion("ID is null");
            return (Criteria) this;
        }

        // 判断ID是否不为空
        public Criteria andIdIsNotNull() {
            addCriterion("ID is not null");
            return (Criteria) this;
        }

        // 判断ID是否等于某个值
        public Criteria andIdEqualTo(Integer value) {
            addCriterion("ID =", value, "id");
            return (Criteria) this;
        }

        // 判断ID是否不等于某个值
        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("ID <>", value, "id");
            return (Criteria) this;
        }

        // 判断ID是否大于某个值
        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("ID >", value, "id");
            return (Criteria) this;
        }

        // 判断ID是否大于等于某个值
        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("ID >=", value, "id");
            return (Criteria) this;
        }

        // 判断ID是否小于某个值
        public Criteria andIdLessThan(Integer value) {
            addCriterion("ID <", value, "id");
            return (Criteria) this;
        }

        // 判断ID是否小于等于某个值
        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("ID <=", value, "id");
            return (Criteria) this;
        }

        // 判断ID是否在某个范围内
        public Criteria andIdIn(List<Integer> values) {
            addCriterion("ID in", values, "id");
            return (Criteria) this;
        }

        // 判断ID是否不在某个范围内
        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("ID not in", values, "id");
            return (Criteria) this;
        }

        // 判断ID是否在某个范围内
        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("ID between", value1, value2, "id");
            return (Criteria) this;
        }

        // 判断ID是否不在某个范围内
        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("ID not between", value1, value2, "id");
            return (Criteria) this;
        }

        // 判断CD_COUPON_ID是否为空
        public Criteria andCdCouponIdIsNull() {
            addCriterion("CD_COUPON_ID is null");
            return (Criteria) this;
        }

        // 判断CD_COUPON_ID是否不为空
        public Criteria andCdCouponIdIsNotNull() {
            addCriterion("CD_COUPON_ID is not null");
            return (Criteria) this;
        }

        // 判断CD_COUPON_ID是否等于某个值
        public Criteria andCdCouponIdEqualTo(Integer value) {
            addCriterion("CD_COUPON_ID =", value, "cdCouponId");
            return (Criteria) this;
        }

        // 判断CD_COUPON_ID是否不等于某个值
        public Criteria andCdCouponIdNotEqualTo(Integer value) {
            addCriterion("CD_COUPON_ID <>", value, "cdCouponId");
            return (Criteria) this;
        }

        // 判断CD_COUPON_ID是否大于某个值
        public Criteria andCdCouponIdGreaterThan(Integer value) {
            addCriterion("CD_COUPON_ID >", value, "cdCouponId");
            return (Criteria) this;
        }

        // 判断CD_COUPON_ID是否大于等于某个值
        public Criteria andCdCouponIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("CD_COUPON_ID >=", value, "cdCouponId");
            return (Criteria) this;
        }

        // 判断CD_COUPON_ID是否小于某个值
        public Criteria andCdCouponIdLessThan(Integer value) {
            addCriterion("CD_COUPON_ID <", value, "cdCouponId");
            return (Criteria) this;
        }

        // 判断CD_COUPON_ID是否小于等于某个值
        public Criteria andCdCouponIdLessThanOrEqualTo(Integer value) {
            addCriterion("CD_COUPON_ID <=", value, "cdCouponId");
            return (Criteria) this;
        }

        // 判断CD_COUPON_ID是否在某个范围内
        public Criteria andCdCouponIdIn(List<Integer> values) {
            addCriterion("CD_COUPON_ID in", values, "cdCouponId");
            return (Criteria) this;
        }

        // 判断CD_COUPON_ID是否不在某个范围内
        public Criteria andCdCouponIdNotIn(List<Integer> values) {
            addCriterion("CD_COUPON_ID not in", values, "cdCouponId");
            return (Criteria) this;
        }

        // 判断CD_COUPON_ID是否在某个范围内
        public Criteria andCdCouponIdBetween(Integer value1, Integer value2) {
            addCriterion("CD_COUPON_ID between", value1, value2, "cdCouponId");
            return (Criteria) this;
        }

        // 判断CD_COUPON_ID是否不在某个范围内
        public Criteria andCdCouponIdNotBetween(Integer value1, Integer value2) {
            addCriterion("CD_COUPON_ID not between", value1, value2, "cdCouponId");
            return (Criteria) this;
        }

        // 判断COUPON_NUMBER是否为空
        public Criteria andCouponNumberIsNull() {
            addCriterion("COUPON_NUMBER is null");
            return (Criteria) this;
        }

        // 判断COUPON_NUMBER是否不为空
        public Criteria andCouponNumberIsNotNull() {
            addCriterion("COUPON_NUMBER is not null");
            return (Criteria) this;
        }

        // 判断COUPON_NUMBER是否等于某个值
        public Criteria andCouponNumberEqualTo(String value) {
            addCriterion("COUPON_NUMBER =", value, "couponNumber");
            return (Criteria) this;
        }

        // 判断COUPON_NUMBER是否不等于某个值
        public Criteria andCouponNumberNotEqualTo(String value) {
            addCriterion("COUPON_NUMBER <>", value, "couponNumber");
            return (Criteria) this;
        }

        // 判断COUPON_NUMBER是否大于某个值
        public Criteria andCouponNumberGreaterThan(String value) {
            addCriterion("COUPON_NUMBER >", value, "couponNumber");
            return (Criteria) this;
        }

        // 判断COUPON_NUMBER是否大于等于某个值
        public Criteria andCouponNumberGreaterThanOrEqualTo(String value) {
            addCriterion("COUPON_NUMBER >=", value, "couponNumber");
            return (Criteria) this;
        }

        // 判断COUPON_NUMBER是否小于某个值
        public Criteria andCouponNumberLessThan(String value) {
            addCriterion("COUPON_NUMBER <", value, "couponNumber");
            return (Criteria) this;
        }

        // 判断COUPON_NUMBER是否小于等于某个值
        public Criteria andCouponNumberLessThanOrEqualTo(String value) {
            addCriterion("COUPON_NUMBER <=", value, "couponNumber");
            return (Criteria) this;
        }

        // 判断COUPON_NUMBER是否包含某个值
        public Criteria andCouponNumberLike(String value) {
            addCriterion("COUPON_NUMBER like", value, "couponNumber");
            return (Criteria) this;
        }

        // 判断COUPON_NUMBER是否不包含某个值
        public Criteria andCouponNumberNotLike(String value) {
            addCriterion("COUPON_NUMBER not like", value, "couponNumber");
            return (Criteria) this;
        }

        // 判断COUPON_NUMBER是否在某个范围内
        public Criteria andCouponNumberIn(List<String> values) {
            addCriterion("COUPON_NUMBER in", values, "couponNumber");
            return (Criteria) this;
        }

        // 判断COUPON_NUMBER是否不在某个范围内
        public Criteria andCouponNumberNotIn(List<String> values) {
            addCriterion("COUPON_NUMBER not in", values, "couponNumber");
            return (Criteria) this;
        }

        // 判断COUPON_NUMBER是否在某个范围内
        public Criteria andCouponNumberBetween(String value1, String value2) {
            addCriterion("COUPON_NUMBER between", value1, value2, "couponNumber");
            return (Criteria) this;
        }

        // 判断COUPON_NUMBER是否不在某个范围内
        public Criteria andCouponNumberNotBetween(String value1, String value2) {
            addCriterion("COUPON_NUMBER not between", value1, value2, "couponNumber");
            return (Criteria) this;
        }

        // 判断REF_TYPE是否为空
        public Criteria andRefTypeIsNull() {
            addCriterion("REF_TYPE is null");
            return (Criteria) this;
        }

        // 判断REF_TYPE是否不为空
        public Criteria andRefTypeIsNotNull() {
            addCriterion("REF_TYPE is not null");
            return (Criteria) this;
        }

        // 判断REF_TYPE是否等于某个值
        public Criteria andRefTypeEqualTo(String value) {
            addCriterion("REF_TYPE =", value, "refType");
            return (Criteria) this;
        }

        // 判断REF_TYPE是否不等于某个值
        public Criteria andRefTypeNotEqualTo(String value) {
            addCriterion("REF_TYPE <>", value, "refType");
            return (Criteria) this;
        }

        // 判断REF_TYPE是否大于某个值
        public Criteria andRefTypeGreaterThan(String value) {
            addCriterion("REF_TYPE >", value, "refType");
            return (Criteria) this;
        }

        // 判断REF_TYPE是否大于等于某个值
        public Criteria andRefTypeGreaterThanOrEqualTo(String value) {
            addCriterion("REF_TYPE >=", value, "refType");
            return (Criteria) this;
        }

        // 判断REF_TYPE是否小于某个值
        public Criteria andRefTypeLessThan(String value) {
            addCriterion("REF_TYPE <", value, "refType");
            return (Criteria) this;
        }

        // 判断REF_TYPE是否小于等于某个值
        public Criteria andRefTypeLessThanOrEqualTo(String value) {
            addCriterion("REF_TYPE <=", value, "refType");
            return (Criteria) this;
        }

        // 判断REF_TYPE是否包含某个值
        public Criteria andRefTypeLike(String value) {
            addCriterion("REF_TYPE like", value, "refType");
            return (Criteria) this;
        }

        // 判断REF_TYPE是否不包含某个值
        public Criteria andRefTypeNotLike(String value) {
            addCriterion("REF_TYPE not like", value, "refType");
            return (Criteria) this;
        }

        // 判断REF_TYPE是否在某个范围内
        public Criteria andRefTypeIn(List<String> values) {
            addCriterion("REF_TYPE in", values, "refType");
            return (Criteria) this;
        }

        // 判断REF_TYPE是否不在某个范围内
        public Criteria andRefTypeNotIn(List<String> values) {
            addCriterion("REF_TYPE not in", values, "refType");
            return (Criteria) this;
        }

        // 判断REF_TYPE是否在某个范围内
        public Criteria andRefTypeBetween(String value1, String value2) {
        // 判断REF_TYPE是否在某个范围内
            addCriterion("REF_TYPE between", value1, value2, "refType");
            return (Criteria) this;
        }

        // 判断REF_TYPE是否不在某个范围内
        public Criteria andRefTypeNotBetween(String value1, String value2) {
        // 判断REF_TYPE是否不在某个范围内
            addCriterion("REF_TYPE not between", value1, value2, "refType");
            return (Criteria) this;
        }

        // 判断REF_NAME是否为空
        public Criteria andRefNameIsNull() {
            addCriterion("REF_NAME is null");
            return (Criteria) this;
        }

        // 判断REF_NAME是否不为空
        public Criteria andRefNameIsNotNull() {
            addCriterion("REF_NAME is not null");
        // 判断REF_NAME是否不为空
            return (Criteria) this;
        }

        // 判断REF_NAME是否等于某个值
        public Criteria andRefNameEqualTo(String value) {
            addCriterion("REF_NAME =", value, "refName");
        // 判断REF_NAME是否等于某个值
            return (Criteria) this;
        }

        // 判断REF_NAME是否不等于某个值
        public Criteria andRefNameNotEqualTo(String value) {
            addCriterion("REF_NAME <>", value, "refName");
        // 判断REF_NAME是否不等于某个值
            return (Criteria) this;
        }

        // 判断REF_NAME是否大于某个值
        public Criteria andRefNameGreaterThan(String value) {
            addCriterion("REF_NAME >", value, "refName");
        // 判断REF_NAME是否大于某个值
            return (Criteria) this;
        }

        // 判断REF_NAME是否大于等于某个值
        public Criteria andRefNameGreaterThanOrEqualTo(String value) {
            // 添加条件，REF_NAME大于等于value
            addCriterion("REF_NAME >=", value, "refName");
            // 返回当前Criteria对象
            return (Criteria) this;
        }

        // 判断REF_NAME是否小于某个值
        public Criteria andRefNameLessThan(String value) {
            addCriterion("REF_NAME <", value, "refName");
            return (Criteria) this;
        }

        // 判断REF_NAME是否小于等于某个值
        public Criteria andRefNameLessThanOrEqualTo(String value) {
            addCriterion("REF_NAME <=", value, "refName");
            return (Criteria) this;
        }

        // 判断REF_NAME是否包含某个值
        public Criteria andRefNameLike(String value) {
            addCriterion("REF_NAME like", value, "refName");
            return (Criteria) this;
        // 判断REF_NAME是否包含某个值
        }

        // 判断REF_NAME是否不包含某个值
        public Criteria andRefNameNotLike(String value) {
            addCriterion("REF_NAME not like", value, "refName");
            return (Criteria) this;
        // 判断REF_NAME是否不包含某个值
        }

        // 判断REF_NAME是否在某个范围内
        public Criteria andRefNameIn(List<String> values) {
            addCriterion("REF_NAME in", values, "refName");
            return (Criteria) this;
        // 判断REF_NAME是否在某个范围内
        }

        // 判断REF_NAME是否不在某个范围内
        public Criteria andRefNameNotIn(List<String> values) {
            addCriterion("REF_NAME not in", values, "refName");
            return (Criteria) this;
        // 判断REF_NAME是否不在某个范围内
        }

        // 判断REF_NAME是否在某个范围内
        public Criteria andRefNameBetween(String value1, String value2) {
            addCriterion("REF_NAME between", value1, value2, "refName");
            return (Criteria) this;
        // 判断REF_NAME是否在某个范围内
        }

        // 判断REF_NAME是否不在某个范围内
        public Criteria andRefNameNotBetween(String value1, String value2) {
            addCriterion("REF_NAME not between", value1, value2, "refName");
            return (Criteria) this;
        // 判断REF_NAME是否不在某个范围内
        }

        // 判断REF_VALUE是否为空
        public Criteria andRefValueIsNull() {
            addCriterion("REF_VALUE is null");
            return (Criteria) this;
        // 判断REF_VALUE是否为空
        }

        // 判断REF_VALUE是否不为空
        public Criteria andRefValueIsNotNull() {
            addCriterion("REF_VALUE is not null");
            return (Criteria) this;
        // 判断REF_VALUE是否不为空
        }

        // 判断REF_VALUE是否等于某个值
        public Criteria andRefValueEqualTo(String value) {
            addCriterion("REF_VALUE =", value, "refValue");
            return (Criteria) this;
        // 判断REF_VALUE是否等于某个值
        }

        // 判断REF_VALUE是否不等于某个值
        public Criteria andRefValueNotEqualTo(String value) {
            addCriterion("REF_VALUE <>", value, "refValue");
            return (Criteria) this;
        // 判断REF_VALUE是否不等于某个值
        }

        // 判断REF_VALUE是否大于某个值
        public Criteria andRefValueGreaterThan(String value) {
            addCriterion("REF_VALUE >", value, "refValue");
            return (Criteria) this;
        // 判断REF_VALUE是否大于某个值
        }

        // 判断REF_VALUE是否大于等于某个值
        public Criteria andRefValueGreaterThanOrEqualTo(String value) {
            addCriterion("REF_VALUE >=", value, "refValue");
            return (Criteria) this;
        }

        // 判断REF_VALUE是否小于某个值
        public Criteria andRefValueLessThan(String value) {
            addCriterion("REF_VALUE <", value, "refValue");
            return (Criteria) this;
        }

        // 判断REF_VALUE是否小于等于某个值
        public Criteria andRefValueLessThanOrEqualTo(String value) {
            addCriterion("REF_VALUE <=", value, "refValue");
            return (Criteria) this;
        }

        // 判断REF_VALUE是否包含某个值
        public Criteria andRefValueLike(String value) {
            addCriterion("REF_VALUE like", value, "refValue");
            return (Criteria) this;
        }

        // 判断REF_VALUE是否不包含某个值
        public Criteria andRefValueNotLike(String value) {
            addCriterion("REF_VALUE not like", value, "refValue");
            return (Criteria) this;
        }

        // 判断REF_VALUE是否在某个范围内
        public Criteria andRefValueIn(List<String> values) {
            addCriterion("REF_VALUE in", values, "refValue");
            return (Criteria) this;
        }

        // 判断REF_VALUE是否不在某个范围内
        public Criteria andRefValueNotIn(List<String> values) {
            addCriterion("REF_VALUE not in", values, "refValue");
            return (Criteria) this;
        }

        // 判断REF_VALUE是否在某个范围内
        public Criteria andRefValueBetween(String value1, String value2) {
            addCriterion("REF_VALUE between", value1, value2, "refValue");
            return (Criteria) this;
        }

        // 判断REF_VALUE是否不在某个范围内
        public Criteria andRefValueNotBetween(String value1, String value2) {
            addCriterion("REF_VALUE not between", value1, value2, "refValue");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}